var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  useHovering: () => useHovering
});
var import_react = __toModule(require("react"));
function useHovering(ref, { enterDelay = 0, exitDelay = 0 } = {}) {
  const op = import_react.default.useRef(null);
  const [hovering, setHovering] = import_react.default.useState(false);
  const hoverOp = import_react.default.useCallback((value) => {
    clearTimeout(op.current);
    if (value && enterDelay || !value && exitDelay) {
      op.current = setTimeout(() => {
        setHovering(value);
      }, value ? enterDelay : exitDelay);
    } else {
      setHovering(value);
    }
  }, [enterDelay, exitDelay]);
  import_react.default.useEffect(() => {
    if (!ref.current) {
      return;
    }
    const node = ref.current;
    const on = () => {
      hoverOp(true);
    };
    const off = () => {
      hoverOp(false);
    };
    const outsideOff = (e) => {
      if (node && !node.contains(e.target)) {
        hoverOp(false);
      }
    };
    node.addEventListener("mouseenter", on);
    node.addEventListener("mouseleave", off);
    node.addEventListener("mousemove", on);
    node.addEventListener("focus", on);
    node.addEventListener("blur", off);
    document.addEventListener("mousemove", outsideOff);
    return () => {
      node.removeEventListener("mouseenter", on);
      node.removeEventListener("mouseleave", off);
      node.removeEventListener("mousemove", on);
      node.removeEventListener("focus", on);
      node.removeEventListener("blur", off);
      document.removeEventListener("mousemove", outsideOff);
    };
  }, [hoverOp]);
  return hovering;
}
//# sourceMappingURL=index.js.map
